Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.wlevs.ede.impl
Class ScopedExecutor

    java.lang.Object
      |
      +--java.util.concurrent.AbstractExecutorService
            |
            +--com.bea.wlevs.ede.impl.ScopedExecutor

public class ScopedExecutor
extends AbstractExecutorService
implements BlockingQueueExecutor

Work copied from Doug Lea's ThreadPoolExecutor

Inner Class Summary
`static class` | `ScopedExecutor.AbortPolicy` A handler for rejected tasks that throws a `RejectedExecutionException`.
`static class` | `ScopedExecutor.CallerRunsPolicy` A handler for rejected tasks that runs the rejected task directly in the calling thread of the `execute` method, unless the executor has been shut down, in which case the task is discarded.
`static class` | `ScopedExecutor.DiscardOldestPolicy` A handler for rejected tasks that discards the oldest unhandled request and then retries `execute`, unless the executor is shut down, in which case the task is discarded.
`static class` | `ScopedExecutor.DiscardPolicy` A handler for rejected tasks that silently discards the rejected task.

Constructor Summary
`ScopedExecutor(int corePoolSize, int maximumPoolSize, long keepAliveTime, TimeUnit unit, BlockingQueue workQueue, WorkFactory workFactory, WorkManager workManager, RejectedExecutionHandler handler)`

Method Summary
`protected void` | `afterExecute(Runnable r, Throwable t)` Method invoked upon completion of execution of the given Runnable.
`boolean` | `awaitTermination(long timeout, TimeUnit unit)`
`protected void` | `beforeExecute(Work w, Runnable r)` Method invoked prior to executing the given Runnable in the given thread.
`void` | `execute(Runnable command)` Executes the given task sometime in the future.
`protected void` | `finalize()` Invokes `shutdown` when this executor is no longer referenced.
`int` | `getActiveCount()` Returns the approximate number of threads that are actively executing tasks.
`long` | `getCompletedTaskCount()` Returns the approximate total number of tasks that have completed execution.
`int` | `getCorePoolSize()` Returns the core number of threads.
`long` | `getKeepAliveTime(TimeUnit unit)` Returns the thread keep-alive time, which is the amount of time which threads in excess of the core pool size may remain idle before being terminated.
`int` | `getLargestPoolSize()` Returns the largest number of threads that have ever simultaneously been in the pool.
`int` | `getMaximumPoolSize()` Returns the maximum allowed number of threads.
`int` | `getPoolSize()` Returns the current number of threads in the pool.
`BlockingQueue` | `getQueue()` Returns the task queue used by this executor.
`RejectedExecutionHandler` | `getRejectedExecutionHandler()` Returns the current handler for unexecutable tasks.
`long` | `getTaskCount()` Returns the approximate total number of tasks that have been scheduled for execution.
`WorkFactory` | `getWorkFactory()` Returns the thread factory used to create new threads.
`boolean` | `isShutdown()`
`boolean` | `isTerminated()`
`boolean` | `isTerminating()` Returns true if this executor is in the process of terminating after `shutdown` or `shutdownNow` but has not completely terminated.
`int` | `prestartAllCoreThreads()` Starts all core threads, causing them to idly wait for work.
`boolean` | `prestartCoreThread()` Starts a core thread, causing it to idly wait for work.
`void` | `purge()` Tries to remove from the work queue all `Future` tasks that have been cancelled.
`boolean` | `remove(Runnable task)` Removes this task from the executor's internal queue if it is present, thus causing it not to be run if it has not already started.
`void` | `setCorePoolSize(int corePoolSize)` Sets the core number of threads.
`void` | `setKeepAliveTime(long time, TimeUnit unit)` Sets the time limit for which threads may remain idle before being terminated.
`void` | `setMaximumPoolSize(int maximumPoolSize)` Sets the maximum allowed number of threads.
`void` | `setRejectedExecutionHandler(RejectedExecutionHandler handler)` Sets a new handler for unexecutable tasks.
`void` | `setWorkFactory(WorkFactory workFactory)` Sets the thread factory used to create new threads.
`void` | `setWorkManager(WorkManager workManager)`
`void` | `shutdown()` Initiates an orderly shutdown in which previously submitted tasks are executed, but no new tasks will be accepted.
`List` | `shutdownNow()` Attempts to stop all actively executing tasks, halts the processing of waiting tasks, and returns a list of the tasks that were awaiting execution.
`protected void` | `terminated()` Method invoked when the Executor has terminated.

Methods inherited from class java.util.concurrent.AbstractExecutorService
`invokeAll, invokeAll, invokeAny, invokeAny, submit, submit, submit`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ScopedExecutor

    public ScopedExecutor(int corePoolSize,
                          int maximumPoolSize,
                          long keepAliveTime,
                          TimeUnit unit,
                          BlockingQueue workQueue,
                          WorkFactory workFactory,
                          WorkManager workManager,
                          RejectedExecutionHandler handler)

Method Detail

### execute

    public void execute(Runnable command)

  Executes the given task sometime in the future. The task may execute in a new thread or in an existing pooled thread. If the task cannot be submitted for execution, either because this executor has been shutdown or because its capacity has been reached, the task is handled by the current `RejectedExecutionHandler`.

  Parameters:
    `command` - the task to execute
  Throws:
    RejectedExecutionException - at discretion of `RejectedExecutionHandler`, if task cannot be accepted for execution
    NullPointerException - if command is null

### shutdown

    public void shutdown()

  Initiates an orderly shutdown in which previously submitted tasks are executed, but no new tasks will be accepted. Invocation has no additional effect if already shut down.

  Throws:
    SecurityException - if a security manager exists and shutting down this ExecutorService may manipulate threads that the caller is not permitted to modify because it does not hold `RuntimePermission``("modifyThread")`, or the security manager's `checkAccess` method denies access.

### shutdownNow

    public List shutdownNow()

  Attempts to stop all actively executing tasks, halts the processing of waiting tasks, and returns a list of the tasks that were awaiting execution.

  This implementation cancels tasks via `Thread.interrupt()`, so if any tasks mask or fail to respond to interrupts, they may never terminate.

  Returns:
    list of tasks that never commenced execution
  Throws:
    SecurityException - if a security manager exists and shutting down this ExecutorService may manipulate threads that the caller is not permitted to modify because it does not hold `RuntimePermission``("modifyThread")`, or the security manager's `checkAccess` method denies access.

### isShutdown

    public boolean isShutdown()

### isTerminating

    public boolean isTerminating()

  Returns true if this executor is in the process of terminating after `shutdown` or `shutdownNow` but has not completely terminated. This method may be useful for debugging. A return of `true` reported a sufficient period after shutdown may indicate that submitted tasks have ignored or suppressed interruption, causing this executor not to properly terminate.

  Returns:
    true if terminating but not yet terminated.

### isTerminated

    public boolean isTerminated()

### awaitTermination

    public boolean awaitTermination(long timeout,
                                    TimeUnit unit)
                             throws InterruptedException

### finalize

    protected void finalize()

  Invokes `shutdown` when this executor is no longer referenced.

  Overrides:
    finalize in class Object

### setWorkFactory

    public void setWorkFactory(WorkFactory workFactory)

  Sets the thread factory used to create new threads.

  Parameters:
    `workFactory` - the new thread factory
  Throws:
    NullPointerException - if workFactory is null
  See Also:
    `getWorkFactory()`

### setWorkManager

    public void setWorkManager(WorkManager workManager)

### getWorkFactory

    public WorkFactory getWorkFactory()

  Returns the thread factory used to create new threads.

  Returns:
    the current thread factory
  See Also:
    `setWorkFactory(com.bea.wlevs.ede.WorkFactory)`

### setRejectedExecutionHandler

    public void setRejectedExecutionHandler(RejectedExecutionHandler handler)

  Sets a new handler for unexecutable tasks.

  Parameters:
    `handler` - the new handler
  Throws:
    NullPointerException - if handler is null
  See Also:
    `getRejectedExecutionHandler()`

### getRejectedExecutionHandler

    public RejectedExecutionHandler getRejectedExecutionHandler()

  Returns the current handler for unexecutable tasks.

  Returns:
    the current handler
  See Also:
    `setRejectedExecutionHandler(com.bea.wlevs.ede.RejectedExecutionHandler)`

### getQueue

    public BlockingQueue getQueue()

  Returns the task queue used by this executor. Access to the task queue is intended primarily for debugging and monitoring. This queue may be in active use. Retrieving the task queue does not prevent queued tasks from executing.
  Specified by:
    getQueue in interface BlockingQueueExecutor

  Returns:
    the task queue

### remove

    public boolean remove(Runnable task)

  Removes this task from the executor's internal queue if it is present, thus causing it not to be run if it has not already started.

  This method may be useful as one part of a cancellation scheme. It may fail to remove tasks that have been converted into other forms before being placed on the internal queue. For example, a task entered using `submit` might be converted into a form that maintains `Future` status. However, in such cases, method `purge()` may be used to remove those Futures that have been cancelled.

  Parameters:
    `task` - the task to remove
  Returns:
    true if the task was removed

### purge

    public void purge()

  Tries to remove from the work queue all `Future` tasks that have been cancelled. This method can be useful as a storage reclamation operation, that has no other impact on functionality. Cancelled tasks are never executed, but may accumulate in work queues until worker threads can actively remove them. Invoking this method instead tries to remove them now. However, this method may fail to remove tasks in the presence of interference by other threads.

### setCorePoolSize

    public void setCorePoolSize(int corePoolSize)

  Sets the core number of threads. This overrides any value set in the constructor. If the new value is smaller than the current value, excess existing threads will be terminated when they next become idle. If larger, new threads will, if needed, be started to execute any queued tasks.

  Parameters:
    `corePoolSize` - the new core size
  Throws:
    IllegalArgumentException - if `corePoolSize` less than zero
  See Also:
    `getCorePoolSize()`

### getCorePoolSize

    public int getCorePoolSize()

  Returns the core number of threads.

  Returns:
    the core number of threads
  See Also:
    `setCorePoolSize(int)`

### prestartCoreThread

    public boolean prestartCoreThread()

  Starts a core thread, causing it to idly wait for work. This overrides the default policy of starting core threads only when new tasks are executed. This method will return `false` if all core threads have already been started.

  Returns:
    true if a thread was started

### prestartAllCoreThreads

    public int prestartAllCoreThreads()

  Starts all core threads, causing them to idly wait for work. This overrides the default policy of starting core threads only when new tasks are executed.

  Returns:
    the number of threads started.

### setMaximumPoolSize

    public void setMaximumPoolSize(int maximumPoolSize)

  Sets the maximum allowed number of threads. This overrides any value set in the constructor. If the new value is smaller than the current value, excess existing threads will be terminated when they next become idle.

  Parameters:
    `maximumPoolSize` - the new maximum
  Throws:
    IllegalArgumentException - if maximumPoolSize less than zero or the core pool size
  See Also:
    `getMaximumPoolSize()`

### getMaximumPoolSize

    public int getMaximumPoolSize()

  Returns the maximum allowed number of threads.

  Returns:
    the maximum allowed number of threads
  See Also:
    `setMaximumPoolSize(int)`

### setKeepAliveTime

    public void setKeepAliveTime(long time,
                                 TimeUnit unit)

  Sets the time limit for which threads may remain idle before being terminated. If there are more than the core number of threads currently in the pool, after waiting this amount of time without processing a task, excess threads will be terminated. This overrides any value set in the constructor.

  Parameters:
    `time` - the time to wait. A time value of zero will cause excess threads to terminate immediately after executing tasks.
    `unit` - the time unit of the time argument
  Throws:
    IllegalArgumentException - if time less than zero
  See Also:
    `getKeepAliveTime(java.util.concurrent.TimeUnit)`

### getKeepAliveTime

    public long getKeepAliveTime(TimeUnit unit)

  Returns the thread keep-alive time, which is the amount of time which threads in excess of the core pool size may remain idle before being terminated.

  Parameters:
    `unit` - the desired time unit of the result
  Returns:
    the time limit
  See Also:
    `setKeepAliveTime(long, java.util.concurrent.TimeUnit)`

### getPoolSize

    public int getPoolSize()

  Returns the current number of threads in the pool.

  Returns:
    the number of threads

### getActiveCount

    public int getActiveCount()

  Returns the approximate number of threads that are actively executing tasks.

  Returns:
    the number of threads

### getLargestPoolSize

    public int getLargestPoolSize()

  Returns the largest number of threads that have ever simultaneously been in the pool.

  Returns:
    the number of threads

### getTaskCount

    public long getTaskCount()

  Returns the approximate total number of tasks that have been scheduled for execution. Because the states of tasks and threads may change dynamically during computation, the returned value is only an approximation, but one that does not ever decrease across successive calls.

  Returns:
    the number of tasks

### getCompletedTaskCount

    public long getCompletedTaskCount()

  Returns the approximate total number of tasks that have completed execution. Because the states of tasks and threads may change dynamically during computation, the returned value is only an approximation, but one that does not ever decrease across successive calls.

  Returns:
    the number of tasks

### beforeExecute

    protected void beforeExecute(Work w,
                                 Runnable r)

  Method invoked prior to executing the given Runnable in the given thread. This method is invoked by thread `t` that will execute task `r`, and may be used to re-initialize ThreadLocals, or to perform logging. Note: To properly nest multiple overridings, subclasses should generally invoke `super.beforeExecute` at the end of this method.

  Parameters:
    `t` - the thread that will run task r.
    `r` - the task that will be executed.

### afterExecute

    protected void afterExecute(Runnable r,
                                Throwable t)

  Method invoked upon completion of execution of the given Runnable. This method is invoked by the thread that executed the task. If non-null, the Throwable is the uncaught exception that caused execution to terminate abruptly. Note: To properly nest multiple overridings, subclasses should generally invoke `super.afterExecute` at the beginning of this method.

  Parameters:
    `r` - the runnable that has completed.
    `t` - the exception that caused termination, or null if execution completed normally.

### terminated

    protected void terminated()

  Method invoked when the Executor has terminated. Default implementation does nothing. Note: To properly nest multiple overridings, subclasses should generally invoke `super.terminated` within this method.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD